%define name talpo
%define version 0.0.20110914.1git65c4215

%define _meltsources %(gcc -print-file-name=plugin/melt-sources)
%define _meltmodules %(gcc -print-file-name=plugin/melt-modules)

Name:		%{name}
Version:	%{version}
Release:	4
License:	GPLv3
Summary:	Talpo is GCC MELT user-programmable checker
Group:		Development/C
URL:		https://gitorious.org/%{name}/%{name}
Source0:	%{name}-%{version}.tar.bz2

Requires:	%{name}-sources
Requires:	%{name}-modules
Requires:	gccmelt
BuildRequires:	gccmelt
## Needed because BuildRequires of gccmelt won't get installed
## inside the building chroot
BuildRequires:	gcc-plugin-devel
BuildRequires:	gmp-devel
BuildRequires:	ppl-devel
BuildRequires:	ppl_c-devel
BuildRequires:	mpfr-devel
BuildRequires:	libmpc-devel

%description
GCC MELT is a GCC plugin providing a lispy domain specific
language to easily code GCC extensions in.

Talpo is such of one of theses extensions, aiming at providing
compile-time complex and easy-to-use checking.

%package sources
Summary:	Talpo's MELT sources
Requires:	gccmelt
Requires:	%{name}
BuildArch:	noarch

%description sources
This package contains Talpo's MELT sources files.

%package modules
Summary:	Talpo's MELT modules
Requires:	gccmelt
Requires:	%{name}

%description modules
This package contains Talpo's MELT modules files.

%package doc
Summary:	Talpo's Documentation
BuildArch:	noarch

%description doc
This package provides Talpo's documentation

%files
%{_bindir}/talpo

%files sources
%{_meltsources}/*.melt
%{_meltsources}/*.c
%{_meltsources}/*.modlis

%files modules
%{_meltmodules}/*.so

%files doc
%doc README AdvancedREADME
%{_docdir}/%{name}-doc/examples/

%prep
%setup -q

%apply_patches

%build
# disable make -j for now
# must have a new melt-module.mk which disables -j system wide before re-enabling here.
make -f Makefile-plugin CC=gcc

%install

pushd examples
for f in $(find . -type f); do
	%{__install} -m644 -D $f %{buildroot}%{_docdir}/%{name}-doc/examples/$f
done;
popd

%makeinstall_std -f Makefile-plugin PREFIX=%{_prefix}/

%clean
rm -fr %{buildroot}


%changelog
* Fri Oct 21 2011 Alexandre Lissy <alissy@mandriva.com> 0.0.20110914.1git65c4215-4
+ Revision: 705587
- Rebuilding for latest GCC MELT

* Sun Oct 16 2011 Alexandre Lissy <alissy@mandriva.com> 0.0.20110914.1git65c4215-3
+ Revision: 704860
- Rebuilt talpo for melt 0.9.1rc1

* Wed Sep 28 2011 Alexandre Lissy <alissy@mandriva.com> 0.0.20110914.1git65c4215-2
+ Revision: 701658
- Rebuilding for new GCC MELT

* Wed Sep 14 2011 Alexandre Lissy <alissy@mandriva.com> 0.0.20110914.1git65c4215-1
+ Revision: 699752
- Fake release update (previous version in buildsystem will be invalid)

* Wed Sep 14 2011 Alexandre Lissy <alissy@mandriva.com> 0.0.20110914git65c4215-1
+ Revision: 699751
- Updating talpo's version only.

* Fri Sep 02 2011 Alexandre Lissy <alissy@mandriva.com> 0.0.20110830.3git65c4215-2
+ Revision: 697852
- Update release for melt 0.9rc0

* Tue Aug 30 2011 Alexandre Lissy <alissy@mandriva.com> 0.0.20110830.3git65c4215-1
+ Revision: 697520
- Updating to latest git snapshot, removing merged patches
- Updating to latest git snapshot
- Updating patches not yet upstream
- Update to latest git snapshot

* Sun Aug 28 2011 Alexandre Lissy <alissy@mandriva.com> 0.0.20110828.4gitd4d941f-1
+ Revision: 697258
- Updating to latest git snapshot
- Several fixes (until upstream merges them)
- Adding Requires: against gccmelt and talpo
- Changing path for modlis
- Latest talpo for MELT 0.9
- Adding READ_STRV
- Build process for MELT 0.9
- Updating talpo for GCC MELT 0.9

* Mon Aug 22 2011 Alexandre Lissy <alissy@mandriva.com> 0.0.20110822.4git6144eb5-1
+ Revision: 696195
- Adding fix for bad handling of arguments in wrapper

* Mon Aug 22 2011 Alexandre Lissy <alissy@mandriva.com> 0.0.20110822.3gite666bf3-1
+ Revision: 696193
- Updating to latest git snapshot
- Adding not yet upstream /usr/bin/talpo wrapper
- Adding not yet upstream patch for modlis installation
- Adding missing modlis files
- Adding AdvancedREADME to documentation
- Adding examples to documentation

* Mon Aug 22 2011 Alexandre Lissy <alissy@mandriva.com> 0.0.20110822git31c0289-1
+ Revision: 696169
- Updating to latest talpo git snapshot for GCC 4.6/MELT 0.8
- Update specfile, source tarball and introducing patches produced by gitrpm
  helper. This allows for better separation, instead of having patched tarball.
- Adding new stuff for git rpm helper

* Fri Aug 05 2011 Alexandre Lissy <alissy@mandriva.com> 0.0.20110805.5gitbe6de7d-1
+ Revision: 693324
- Adding missing BuildRequires
- Latest Talpo 0.8 snapshot with our patches
- Use talpo for melt 0.8
- Update for latest talpo for MELT 0.8
- Fix build (avoid -j) and install (using the correct Makefile-plugin)
- Use git commit id in package version
- Fix inconsistency in package file name and source reference
- Re-enable commit id since code is in dev ...
- Set CC to gcc instead of default value in Makefile-plugin
- Update to latest talpo snapshot
- Update talpo's spec to latest changes

* Sat Jul 16 2011 Alexandre Lissy <alissy@mandriva.com> 0.0.20110716git2658915-1
+ Revision: 690129
- Update to latest git snapshot

* Fri Jul 08 2011 Alexandre Lissy <alissy@mandriva.com> 0.0.20110708git6a72e12-1
+ Revision: 689318
- Updating to latest git snapshot
- Revert.
- Test
- Fake target

* Wed Jul 06 2011 Alexandre Lissy <alissy@mandriva.com> 0.0.20110706git72bbaba-1
+ Revision: 688956
- Updating to latest git revision
- Updating spec template to use version and release from Git
- Using gitrpm stuff

* Fri Jul 01 2011 Alexandre Lissy <alissy@mandriva.com> 0.0.20110701git44d9078-1
+ Revision: 688506
- Introducing the talpo project
- Created package structure for talpo.

